<template>
  <div class="create-container">
    <div class="container">
      <div class="title">
        <span>
          Create event
        </span>
      </div>
      <div class="form-container">
        <form class="create">
          <div class="field">
            <label for="">Title</label>
            <input type="text" maxlength="50" placeholder="Your awesome Title" v-model="form.title">
          </div>
          <div class="field">
            <label for="">Short description</label>
            <textarea name="" id="" cols="30" rows="5" maxlength="150" placeholder="Your amazing Short description" v-model="form.shortDescription"></textarea>
          </div>
          <div class="field">
            <label for="">Long description</label>
            <textarea name="" id="" cols="30" rows="5" maxlength="500" placeholder="Your super Long description" v-model="form.longDescription"></textarea>
          </div>
          <div class="field">
            <label for="" >Location</label>
            <input maxlength="50" placeholder="Your breathtaking Location" v-model="form.location" />
          </div>
          <div class="field">
            <label for="" >Date</label>
            <input type="datetime-local" placeholder="Your incredible Date" v-model="form.date" />
          </div>
          <div class="field">
            <label for="">Price</label>
            <input  placeholder="Your astonishing Price (type 0 if free)" type="number" min="0" max="1000000" v-model="form.price" />
          </div>
          <div class="field">
            <label for="">Image</label>
            <input placeholder="Your Image" type="file" id="file" ref="imageFile" @change="previewFiles" />
          </div>
          <!-- categories -->
          <!-- tags -->
          <div class="submit" @click="confirm">Submit</div>
        </form>
        <div class="image">
          <img src="@/assets/working.svg" alt="">
        </div>
        <img ref="img-container">
      </div>
    </div>
  </div>
</template>
<script>
import { EVENTS, MODAL, PROFILE } from '@/store/types'
import { fillDate } from '@/helpers'
import { mapGetters } from 'vuex'
import axios from 'axios'
export default {
  name: 'CreateEvent',
  data: () => ({
    form: {
      title: '',
      shortDescription: '',
      longDescription: '',
      location: '',
      date: fillDate(),
      price: null
    },
    files: []
  }),
  computed: {
    ...mapGetters({
      isAuth: PROFILE.GETTER.GET_IS_AUTHORIZED
    })
  },
  watch: {
    'form.price': function (price) {
      console.log('helluu', price)
      if (price < 0) this.form.price = 0
      if (price > 1000000) this.form.price = 1000000
    }
  },
  methods: {
    async confirm () {
      if (!this.isAuth) {
        this.$store.commit(MODAL.MUTATION.SET_IS_MODAL_OPEN, true)
        this.$store.commit(MODAL.MUTATION.SET_MODAL_CONTENT, `You must be logged in!`)
        this.$store.commit(MODAL.MUTATION.SET_MODAL_ICON, 'error')
        return
      }
      // eslint-disable-next-line no-unreachable
      if (Object.values(this.form).find(c => !c)) return
      try {
        try {
          const formData = new FormData()
          formData.append('imageFile', this.files[0])
          await axios.post('http://localhost:9192/image/upload', formData, { headers: { 'Content-Type': 'multipart/form-data' } })
        } catch (err) {
          console.error('poui', err)
        }
        await this.$store.dispatch(EVENTS.ACTION.CREATE_EVENT, { ...this.form, date: `${this.form.date}:07.052Z`, imageName: this.files[0].name })
        this.$router.push('/events')
        setTimeout(() => {
          this.$store.commit(MODAL.MUTATION.SET_IS_MODAL_OPEN, true)
          this.$store.commit(MODAL.MUTATION.SET_MODAL_CONTENT, `Successfully created event!`)
          this.$store.commit(MODAL.MUTATION.SET_MODAL_ICON, 'success')
        }, 200)
      // eslint-disable-next-line no-unreachable
      } catch (err) {
        this.$store.commit(MODAL.MUTATION.SET_IS_MODAL_OPEN, true)
        this.$store.commit(MODAL.MUTATION.SET_MODAL_CONTENT, `Error on create event: ${err}`)
        this.$store.commit(MODAL.MUTATION.SET_MODAL_ICON, 'error')
      }
    },
    async previewFiles () {
      this.files = this.$refs.imageFile.files

      // const self = this
      // axios.get('http://localhost:9192/image/get/banner.png', {
      //   // responseType: 'blob'
      // }).then(response => {
      //   console.log(typeof (response.data))
      //   var blob = response.data.picture
      //   console.log('blob', blob)
      //   const imageUrl = `data:image/png;base64,${blob}`
      //   console.log(`self.$refs['img-container']`, self.$refs['img-container'])
      //   console.log('imageUrl', imageUrl)
      //   self.$refs['img-container'].src = imageUrl
      // })
    }
  }
}
</script>
<style lang="scss" scoped>
input {
  font-family: monospace;
}
.create-container {
  display: flex;
  align-items: center;
  display: flex;
  flex-direction: column;
  padding-bottom: 40px;

  .container {
    max-width: 1200px;
    width: 100%;
  }

  .form-container {
    display: flex;
    justify-content: space-between;

    .image {
      max-width: 500px;
      width: 100%;
      height: 500px;
      img {
        width: 100%;
        height: 100%
      }
    }
  }

  .title {
    font-size: 50px;
    margin-top: 20px;
    margin-bottom: 100px;
    text-align: start;
    max-width: 1200px;
    width: 100%;
    span {
      border-bottom: #ff6392 10px solid;
      padding-right: 70px;
    }
  }
}
.create {
  max-width: 500px;
  width: 100%;

  .field {
    display: flex;
    flex-direction: column;
    margin-bottom: 30px;
    font-size: 24px;

    label {
      text-align: start;
      margin-bottom: 10px;
    }

    input {
      font-size: 18px;
      padding: 10px 10px;
    }

    textarea {
      resize: none;
      font-size: 18px;
      padding: 10px 10px;
    }
  }
  .submit {
    width: 100%;
    margin-top: 40px;
    padding: 10px 0;
    background: #ff6392;
    font-size: 24px;
    border: 0;
    color: #2c3e50;
    cursor: pointer;
  }
}
</style>
